ljEdit = new Object();

if (window.arguments) {
	LiveJournal = window.arguments[0];
	var postnum = window.arguments[1];
}

function InitEditing() {
	ljPost.usejournal = window.arguments[2];
	document.getElementById("usejournal").collapsed = true;
	document.getElementById("postbutton").setAttribute("label", "Save");
	document.getElementById("postbutton").setAttribute("oncommand", "ljEdit.saveEdit()");
	document.getElementById("postbutton").setAttribute("disabled", "true");
	document.getElementById("maindisabler").setAttribute("disabled", true);
	if (postnum == -1) {
		document.getElementById("cmd_lastentry").setAttribute("disabled", true);
	}
	
	document.getElementById("progressbar").mode = "undetermined";
	document.getElementById("statuslabel").value = "Loading...";
	document.getElementById("statuswhat").value = "Loading the selected entry...";
	document.getElementById("messagedeck").selectedIndex = 1;
	window.title = "Deepest Sender: Editing post in " + ljPost.usejournal;
	ljEdit.requestLoadChallenge();
}

ljEdit.requestLoadChallenge = function() {
	this.httpreq = new XMLHttpRequest()
	this.httpreq.onload = this.challengeLoadHandler.onResult;
	this.httpreq.onerror = this.challengeLoadHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	this.httpreq.send("mode=getchallenge");
}

ljEdit.challengeLoadHandler = {
	// In: Nothing.
	// Out: Nothing.
	onResult: function() {
		if (LiveJournal.getResponseData("success", ljEdit.httpreq.responseText) == "OK") {
			var challenge = LiveJournal.getResponseData("challenge", ljEdit.httpreq.responseText);
			ljEdit.loadMessage(challenge);
		} else {
			alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljEdit.httpreq.responseText));
			setTimeout("window.close();", 1);
		}
	},
	onError: function () {
		alert("There was an error connecting to the server.");
		setTimeout("window.close();", 1);
	}
}

ljEdit.loadMessage = function(challengestring) {
	this.httpreq = new XMLHttpRequest();
	this.httpreq.onload = this.loadHandler.onResult;
	this.httpreq.onerror = this.loadHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	var params = new Object();

	params.user = LiveJournal.username;
	params.auth_method = "challenge";
	params.auth_challenge = challengestring;
	params.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	params.ver = 1;
	if (LiveJournal.username != ljPost.usejournal) {
		params.usejournal = ljPost.usejournal;
	}
	params.selecttype = "one";
	params.itemid = postnum;
	params.lineendings = "unix";
	
	var body = "mode=getevents";
	body += LiveJournal.makeParams(params);
	
	this.httpreq.send(body);
}

ljEdit.loadHandler = {
	// In: Nothing.
	// Out: Nothing.
	onResult: function() {
		if (LiveJournal.getResponseData("success", ljEdit.httpreq.responseText) == "OK") {
			var result = ljEdit.httpreq.responseText;
			// Only 1 event is returned for this, but it's still in an array.
			// I just *know* this'll be the most frustrating part out of this entire program.
			
			var eventtime = LiveJournal.getResponseData("events_1_eventtime", result);
			postnum = LiveJournal.getResponseData("events_1_itemid", result);

			var security = LiveJournal.getResponseData("events_1_security", result);
			var subject = LiveJournal.getResponseData("events_1_subject", result);
			var event = LiveJournal.getResponseData("events_1_event", result);
			
			var propstring = "";
			for (i = 1; i <= LiveJournal.getResponseData("prop_count", result); i++) {
				propstring += LiveJournal.getResponseData("prop_" + i + "_name", result) + "\n";
				propstring += LiveJournal.getResponseData("prop_" + i + "_value", result) + "\n";
			}
			
			var mood = LiveJournal.getResponseData("current_mood", propstring);
			var moodid = LiveJournal.getResponseData("current_moodid", propstring);
			var music = LiveJournal.getResponseData("current_music", propstring);
			var dontautoformat = LiveJournal.getResponseData("opt_preformatted", propstring);
			var removecomments = LiveJournal.getResponseData("opt_nocomments", propstring);
			var backdate = LiveJournal.getResponseData("opt_backdated", propstring);
			var pickw = LiveJournal.getResponseData("picture_keyword", propstring);

			var etarray = eventtime.split(" ");
			var datearray = etarray[0].split("-");
			var timearray = etarray[1].split(":");
			ljPost.year = parseInt(datearray[0], 10);
			ljPost.month = parseInt(datearray[1], 10);
			ljPost.day = parseInt(datearray[2], 10);
			ljPost.hour = parseInt(timearray[0], 10);
			ljPost.minute = parseInt(timearray[1], 10);
			ljPost.second = parseInt(timearray[2], 10);
			
			var secnode = document.getElementById("security");
			if (security) {
				switch (security) {
					case "private":
						secnode.selectedIndex = 1;
						dsPosts.changeSecurity(1, true);
						break;
					case "usemask":
						var allowmask = parseInt(LiveJournal.getResponseData("events_1_allowmask", result), 10);
						if (allowmask == 1) {
							secnode.selectedIndex = 2;
							dsPosts.changeSecurity(1, true);
						} else {
							secnode.selectedIndex = 3;
							ljPost.allowmask = allowmask;
							dsPosts.changeSecurity(3, true);
						}
						break;
				}
			} else {
				secnode.selectedIndex = 0;
				dsPosts.changeSecurity(0, true);
			}
			if (subject) {
				document.getElementById("subject").value = subject;
			}
			document.getElementById("messagesource").value = event;
			dsMidas.syncNormalTab();
			// Otherwise you can't backspace until you enter some text. Hooray for workarounds!
			document.getElementById("message").contentDocument.designMode = "On";
			if (moodid) {
				for (i = 0; i < LiveJournal.moods.length; i++) {
					if (LiveJournal.moods[i].id == moodid) {
						document.getElementById("moods").selectedIndex = i;
						break;
					}
				}
			} else if (mood) {
				document.getElementById("moods").label = mood;
			}
			if (music) {
				document.getElementById("music").value = music;
			}
			if (dontautoformat) {
				ljPost.dontautoformat = true;
				dsMidas.dontautoformat = true;
			}
			if (removecomments) {
				ljPost.removecomments = true;
			}
			if (backdate) {
				ljPost.backdate = true;
			}
			if (pickw) {
				var picmenu = document.getElementById("picture");
				for (i = 0; i < LiveJournal.pickws.length; i++) {
					if (LiveJournal.pickws[i].pickw == pickw) {
						picmenu.selectedIndex = i + 1;
						dsPosts.changePicture(picmenu);
						break;
					}
				}
			}
			document.getElementById("maindisabler").removeAttribute("disabled");
			document.getElementById("postbutton").removeAttribute("disabled");
			document.getElementById("messagedeck").selectedIndex = 0;
		} else {
			alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljEdit.httpreq.responseText));
		}
	},
	onError: function () {
		alert("There was an error connecting to the server.");
	}
}

ljEdit.saveEdit = function() {
	if (this.posting) {
		this.posting = false;
		ljedit.httpreq.abort();
		document.getElementById("maindisabler").removeAttribute("disabled");
		document.getElementById("messagedeck").selectedIndex = 0;
		document.getElementById("postbutton").label = "Save";
	} else {
		if (dsPrefs.getBoolPref("SpellCheckOnPost")) {
			// goDoCommand won't work for some reason.
			eval(document.getElementById("cmd_spell").getAttribute("oncommand"));
		}

		document.getElementById("postbutton").label = "Cancel";
		document.getElementById("maindisabler").setAttribute("disabled", true);
		document.getElementById("statuslabel").value = "Editing...";
		document.getElementById("statuswhat").value = "Saving your post on the server...";
		document.getElementById("progressbar").mode = "undetermined";
		document.getElementById("messagedeck").selectedIndex = 1;
		this.posting = true;
		ljEdit.editPostChallenge();
	}
}


ljEdit.editPostChallenge = function() {
	this.httpreq = new XMLHttpRequest()
	this.httpreq.onload = this.editPostHandler.onResult;
	this.httpreq.onerror = this.editPostHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	this.httpreq.send("mode=getchallenge");
}

ljEdit.editPostHandler = {
	// In: Nothing.
	// Out: Nothing.
	onResult: function() {
		if (LiveJournal.getResponseData("success", ljEdit.httpreq.responseText) == "OK") {
			var challenge = LiveJournal.getResponseData("challenge", ljEdit.httpreq.responseText);
			ljEdit.saveEditedPost(challenge);
		} else {
			alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljEdit.httpreq.responseText));
			setTimeout("window.close();", 1);
		}
	},
	onError: function () {
		alert("There was an error connecting to the server.");
		setTimeout("window.close();", 1);
	}
}

ljEdit.saveEditedPost = function(challengestring) {
	this.httpreq = new XMLHttpRequest();
	this.httpreq.onload = this.editHandler.onResult;
	this.httpreq.onerror = this.editHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	var params = new Object();
	
	params.user = LiveJournal.username;
	params.auth_method = "challenge";
	params.auth_challenge = challengestring;
	params.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	params.ver = 1;
	params.lineendings = "unix";
	params.itemid = postnum;
	var subjectbox = document.getElementById("subject");
	if (subjectbox.value.trim().length > 0) {
		params.subject = subjectbox.value;
	}
	dsMidas.updateSourceTab();
	params.event = document.getElementById("messagesource").value;
	switch (ljPost.security) {
		case 0:
			params.security = "public";
			break;
		case 1:
			params.security = "private";
			break;
		case 2:
			params.security = "usemask";
			params.allowmask = ljPost.allowmask;
			break;
	}
	params.year = ljPost.year;
	params.mon = ljPost.month
	params.day = ljPost.day;
	params.hour = ljPost.hour;
	params.min = ljPost.minute;
	
	if (LiveJournal.username != ljPost.usejournal) {
		params.usejournal = ljPost.usejournal;
	}

	// Ugh. Props will suck.
	var moodbox = document.getElementById("moods"); 
	if ((moodbox.selectedIndex < 0) && (moodbox.label.trim().length > 0)) {
		params.prop_current_mood = moodbox.label;
	} else if (moodbox.selectedIndex >= 0) {
		params.prop_current_moodid = LiveJournal.moods[moodbox.selectedIndex].id;
	}
	
	var musicbox = document.getElementById("music");
	if (musicbox.value.trim().length > 0) {
		params.prop_current_music = musicbox.value.trim();
	}
	
	if (ljPost.dontautoformat.toString() == "true") {
		params.prop_opt_preformatted = 1;
	} else {
		params.prop_opt_preformatted = 0;
	}
	
	if (ljPost.removecomments.toString() == "true") {
		params.prop_opt_nocomments = 1;
	} else {
		params.prop_opt_nocomments = 0;
	}
	
	if (ljPost.backdate.toString() == "true") {
		params.prop_opt_backdated = 1;
	} else {
		params.prop_opt_backdated = 0;
	}
	
	var pickwbox = document.getElementById("picture");
	if (pickwbox.selectedIndex > 0) {
		params.prop_picture_keyword = this.pickw;
	}
	
	var body = "mode=editevent";
	body += LiveJournal.makeParams(params);
	
	document.getElementById("statuswhat").value = "Editing post in journal: " + ljPost.usejournal;
	
	this.httpreq.send(body);
}

ljEdit.editHandler = {
	// In: Nothing.
	// Out: Nothing.
	onResult: function() {
		if (ljEdit.posting) {
			if (LiveJournal.getResponseData("success", ljEdit.httpreq.responseText) == "OK") {
				// Workaround for weird bug where window won't close.
				setTimeout("window.close();", 1);
			} else {
				alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljEdit.httpreq.responseText));
				ljEdit.saveEdit();
			}
		}
	},
	onError: function () {
		if (ljEdit.posting) {
			alert("There was an error connecting to the server.");
			ljEdit.saveEdit();
		}
	}
}
